/* -------------------------------
     Surprise simulator header file
     Version date = 04.03.07
------------------------------- */

/*----------------------------------------------------------------------
COPYRIGHT 2004, 2005 PETER DAVIS
This file is part of "HMS Surprise - Frigate and brig Simulator for
Windows". That program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version. The file is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this file; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
----------------------------------------------------------------------*/

#define   STAYSAILS    7
#define   SQUARESAILS 11
#define   NRSAILS     18
#define   IMAXSHAD    12

HANDLE    hFile ;

HBITMAP   hBitmap_0 ;
HBITMAP   hBitmap_1 ;
HBITMAP   hBitmap_3 ;

HBRUSH    hBlownBrush ;   
HBRUSH    hDeckBrush ;
HBRUSH    hForeAftBrush ;
HBRUSH    hForeSailBrush ;   
HBRUSH    hLandBrush ;
HBRUSH    hMainSailBrush ;   
HBRUSH    hSeaBrush ;
HBRUSH    hSkyBrush ;
HBRUSH    hStaySailBrush ;   

HFONT     MyFont ;

HICON     hIcon ;

HINSTANCE hInstance ;

HMENU     hMenu ;

HPEN      hCoastPen ;
HPEN      hDarkGrayPen ;
HPEN      hGrayPen ;
HPEN      hGreenPen ;
HPEN      hHullPen ;
HPEN      hPinkPen ;
HPEN      hSeaBluePen ;
HPEN      hSkyBluePen ;
HPEN      hThickGrayPen ;
HPEN      hThickGreenPen ;
HPEN      hThickPinkPen ;
HPEN      hMastPen ;
HPEN      hRedPen ;
HPEN      hYellowPen ;

HWND      hwnd ;
HWND      hwndButton[9] ;
HWND      hwndChild[4] ;
HWND      hwndCheck[3] ;
HWND      hwndPropCancelButton ;
HWND      hwndPropOKButton ;
HWND      hwndPropText[60] ;
HWND      hwndProps ; 
HWND      hwndSlider[8] ;
HWND      hwndStatus ;
HWND      hwndText ;

LARGE_INTEGER liCounter ;  // curent value of High Performance timer
LARGE_INTEGER liFrequency ; // Frequency of High Performance timer

OPENFILENAME oFileName ;

POINT     pHull[7] ; //Bezier spline defines hull in Planview
POINT     pStern[4] ; //Bezier spline defines hull in Sternview

WNDPROC   fnOldEditProc ;

BOOL   bAlertHeel ;
BOOL   bAlertLeeway ;
BOOL   bAlertRotat ;
BOOL   bAlertSpeed ;
BOOL   bAutoBearing ;
BOOL   bAutoBearing_2 ;
BOOL   bBrig ;
BOOL   bCompassRing ;
BOOL   bCoupleFore ;
BOOL   bCoupleMizzen ;
BOOL   bEasedJibs ;
BOOL   bEasedStaySails ;
BOOL   bEstablished ;
BOOL   bHelmsman ;
BOOL   bMapMustBePainted ;
BOOL   bMaxTrack ;
BOOL   bModernHelm ;
BOOL   bParalax ; // true = sailplan shows view from wind direction
BOOL   bPaused ;
BOOL   bPlanViewIsChanged ;
BOOL   bPlayBack ;
BOOL   bRecording ;
BOOL   bSailPlanIsChanged ;
BOOL   bSavePosition ;
BOOL   bScroll ;
BOOL   bShowSlipStream ;
BOOL   bSternViewIsChanged ;
BOOL   bTracking = TRUE ;
BOOL   bWindDirChange ;
BOOL   bWindSpeedChange ;
BOOL   bYardsmen ;

int    iAcceleration[6] = { 1, 2, 4, 8, 16, 32 } ; // simulation time acceleration
int    xActual ;
float  fAppWindAngle ;
float  fAppWindDirection ;
float  fAppWindSpeed ;
int    xAuto ; // coordinate of autopilot frame
int    cxAuto ; // width of autopilot frame
int    iBearing ; // bearing of mouse pointer on planview
int    xBearing ; // coordinate of planview bearing
int    yBearing ; // coordinate of planview bearing
float  fBearingTime ; // time bearing on planview last redrawn
int    iBestAngle ;
float  fBottomEdge ;
int    yBottomLine ; // coordinate of last screen line 
float  fBowFactor; // modifies Frontal CSA (frontal aspect is not flat rectangle)
int    cxChildPixels ;
int    xClient ;
int    yClient ;
int    iClicks = -1 ;
int    xClicks[10] ; // coordinate of click on sail plan
int    yClicks[10] ; // coordinate of click on sail plan
int    iCloseHauledAngle ;
float  fCOEForeAft ;
float  fCOEHeight ;
float  fCOELeeward ;
int    xColon ;
float  fCORDistance ; // distance of centre of rotation from midpoint of vessel
float  fCSABow ; // Cross Sectional Area
float  fCSASide ;
float  fCSAStern ;
int    iCycles ; // counter for update cycles per half second
float  fDegToRad = 0.017453293 ;
float  fDegreesPerMin ;
float  fDeltaHeel = 0 ;
float  fDeltaWindDir ;
float  fDeltaWindSpeed ;
int    iDisplayParam = 2 ;
float  fEndOfCycle ;
float  fEffectOfHeel ;
int    iEvent [15] ;
int    iEventCode [15] ;
int    iEventCode2 [15] ;
float  fEventTime [15] ;
int    iFields[5] = { 27, 13, 55, 54, 39 } ; // maximum number of text boxes in dialog window
char   sFileName [_MAX_PATH] ;
char   sFileName2 [_MAX_PATH] ;
int    yFirst ;
int    iFirstForeStaySail ;
int    iFirstMainStaySail ;
int    iFocus ; // dialog field with the focus  
float  fFocleLength ;
float  fForwardDrag ;
float  fForwardThrust ;
int    cxFullScreen;
int    cyFullScreen;
float  fGunDeckHeight ; // height in feet above sealevel
float  fHeading ; // in degrees
float  fHeadingDeviation ;
float  fHeelAngleFactor ; // scale factor to generate appropriate heel
float  fHeelDragFactor ; // arbitrary scale factor for drag against heeling
float  fHeelInertFactor ; // arbitrary scale factor for inertia about longitudinal axis (heel)
float  fHeelingAngle ;
float  fHeelingThrust ;
int    iHeelParamHeight ;
int    iHeelParamWidth ;
float  fHeelResistFactor ;
float  fHeelSpeed ;
int    iHelmAngle ; // Helm: + = starboard helm = port rudder
char   sHelmInstruction[] = "(await orders)" ;
float  fHighest ;
float  fHullCentroid ; // horizontal position of hull centroid
float  fHullEnd ;
float  fHullFactor ; // for above water-line hull
float  fHullSide ;  // above-water hull
int    xHullTemplate[7] = { -480, -1000, -1000, 0 , 1000, 1000, 480 } ;
int    yHullTemplate[7] = { -1000, -360, 360, 1000 , 360, -360, -1000 } ;
       // unscaled coordinates for pHull[]
float  fIncrement ;
float  fIsleLat[13] ; 
float  fIsleLong[13] ; 
float  fIsleRadius[13] ; 
int    xJib ; // coordinate of jib-box 
int    iJibSet ; // jib set in frigate
int    xJibValue ;
int    yJibValue ;
float  fLastDeviation ;
int    iLastMapCounter ;
float  fLastLat ;
float  fLastLong ;
float  fLastRealTime ;
float  fLastRecordTime ;
int    iLastRecTime ;
int    iLastReplayItem ;
float  fLastRotationalThrust ;
float  fLastSimTime ;
float  fLastTime = -1 ;
int    iLastValueToShow = 12 ;
float  fLat[2000] ;
float  fLatitude = 0.0 ;
float  fLeewardDrag ;
float  fLeewardThrust ;
float  fLeewayAngle ;
float  fLeewaySpeed = 0.0 ; // in knots
int    xLeft ;
float  fLeftEdge ;
float  fLon[2000] ; // remember course;
float  fLongitude = 0.0 ;
float  fLowestSailFoot[4] ;
       // Height of foot of Fore course, main course, spanker, jib above water-line
int    iMadeSail = 7; // all sails but royals set
float  fMagnify ;
int    cxMap ;
int    iMapCounter ; // number of track positions used
int    iMapSkip ;
int    iMapSkipFactor ;
float  fMapRadius ;
float  fMapWidth = 0.2 ; // width of map in nautical miles
float  fMassFactor = 1.0 ; // arbitrary conversion factor to convert tons to mass
float  fMastDistance[4] ;
       // Distance of Fore Mast, Main Mast, Mizzen Mast, Jib tack from centre of rotation
float  fMastHeight[3] ; // calculated mast height (hull + sail depths + nominal gaps)
int    xMax ; // width maximized client window
int    yMax ; // height maximized client window
float  fMaxAft ; // distance of furthest point aft from midshipdatum
float  fMaxFore ; // distance of furthest point foreward from midshipdatum
float  fMaxHeelMoment ;
int    iMaxHelmAngle ; // Helm
int    iMaxJibAngle ; // Jib
int    iMaxShad = IMAXSHAD ; // 3de dimension of iCanShad [][][] 
int    iMaxYardAngle[4];
       // Maximum yard brace angle forFore Yard, Main Yard, Crossjack, Mizzen Boom
char   sMessage[120] ; // text of message to show
int    cxMessage ;
int    xMessage ; 
int    yMessage ; 
int    iMessageNr = -1 ;
float  fMessageTime[6] = { 999999 , 999999 , 999999 , 999999 , 999999 , 999999 } ; 
int    iModifyMenu ; // index of modification menu now open (0=ship parameters...5=islands)
char   sMyProgName[20] ;
float  fMyTime ; // timer for automatic tacking
int    iNewHelmAngle = 0 ;
float  fNewLat ; // new position for island
float  fNewLong ;
float  fNewWindDirection ;
float  fNewWindSpeed ;
int    iNewYardAngle[4] ;
float  fNow ; // seconds since startup if no High Performance timer
int    iNrSails = 18; // number of sails
float  fOffsetAngle ;
int    iOfsetBottom ;
int    iOfsetLeft ;
int    iOfsetRight ;
int    iOfsetTop ;
float  fOldAppWindAngle = 0.0 ;
char   sOldDegreesPerMin[10] ;
char   sOldHeading[10] ;
char   sOldHeelingAngle[10] ;
float  fOldItemValue[60] ;
int    iOldJibAngle ;
char   sOldLeewayAngle[10] ;
float  fOldRotatInertFactor ;
int    iOldStaySailAngle ;
int    iOldSpankerStatus ;
int    iOldSpankerAngle ;
char   sOldSpeed[10] ;
char   sOldTrack[10] ;
float  fOldValue[60]; // to save old values during configuration change dialog 
char   sOldWindDirection[10] ;
char   sOldWindDirText[30] ;
char   sOldWindSpeed[10] ;
char   sOldWindSpeedText[30] ;
float  fOneTenth ; // one tenth of current map width
int    xOrgPixels ; // x-origin pixel in sail plan 
char  *sParam[10] =
       {   "Sail Angle" , "Wind striking angle" , "Exposed percentage" , 
           "Effective area" , "Useful percentage of force" , "Useful force" ,
           "Forward thrust" , "Leeward thrust", "Rotational thrust" ,
           "Heeling thrust" } ;
int    xParameter ;
int    yParameter ;
int    iParameterHeight ;
int    iParameterWidth ;
float  fPauseTime ; // time pause button was pressed ;
float  fPi = 3.141592748 ;
int    xPos[12] ; // coordinates of masts and yardarms
int    yPos[12] ; // coordinates of masts and yardarms
float  fQDeckHeight ; // height in feet above sealevel
float  fQDeckLength ;
float  fRealTime ;
float  fRecordStartTime ;
float  fRelWindAngle ;
float  fRequiredHeading ;
float  fResistance ;
float  fRightEdge ;
float  fRightingMoment ;
float  fRotatDragFactor ; // arbitrary scale factor for rotational drag (turning)
float  fRotatInertFactor ; // arbitrary scale factor for interia about vertical axis (turning)
float  fRotatForce[24] ; // wind force acting to generate rotation
float  fRotatInertFactor ; // arbitrary scale factor for interia about vertical axis (turning)
float  fRotationalDrag ;
float  fRotatDragFactor ;
float  fRotationalInertia ;
float  fRotationalSpeed ;
float  fRotationalThrust ;
float  fRudderArea ; // square feet
float  fRudderFactor ; // arbitrary scale factor for effectiveness of rudder vs sail (density of water = 770 * dens. air)
float  fSailAngle[NRSAILS] ; 
int    iSailCanShad[4][NRSAILS][IMAXSHAD] ; // stores sails which can shadow other sails
float  fSailClewDistance[STAYSAILS] ;
float  fSailClewElevation[STAYSAILS] ;
float  fSailCorner[NRSAILS] ;
float  fSailDepth[SQUARESAILS] ; // Depth of square sails
float  fSailEffectiveHead[NRSAILS] ; // height of effective sail top above centre of rotation
float  fSailExposedFract[NRSAILS]; // fraction of sail area delivering thrust
float  fSailFoot[NRSAILS] ; // height of bottom of all sails above centre of rotation
float  fSailFootWidth[SQUARESAILS] ; // Width of foot of square sail (replaced from Surprise.cfg if present)
float  fSailGradientLeft[NRSAILS] ;
float  fSailGradientRight[NRSAILS] ;
float  fSailGradient2[NRSAILS] ;
float  fSailHead[SQUARESAILS] ; // height of top of square sails above centre of rotation
float  fSailHeadDistance[STAYSAILS] ;
float  fSailHeadElevation[STAYSAILS] ;
float  fSailHeadwayForce[NRSAILS+5] ; // wind force acting to generate headway;
float  fSailHeadWidth[SQUARESAILS] ; // Width of head of square sail (replaced from Surprise.cfg if present)
float  fSailHeelForce[NRSAILS+5] ; // wind force acting to generate heeling;
float  fSailInterceptLeft[NRSAILS] ;
float  fSailInterceptRight[NRSAILS] ;
float  fSailIntercept2[NRSAILS] ;
char   sSailLastValue[NRSAILS+5] ; // last displayed value of current sail parameter
float  fSailLeewayForce[NRSAILS+5] ; // wind force acting to generate leeway
int    iSailMaxReefs[NRSAILS] ; // Maximum number of reefs
float  fSailMaxSpeed[NRSAILS] ;
float  fSailMeanHeight[NRSAILS] ; // height om centre of (set part of) sail above centre of rotation
char   sSailName[NRSAILS][24] ; // sail names
int    iSailOldSSStatus[STAYSAILS] ; // old staysail status
int    xSailParameter[NRSAILS+5] ; // x-coordinate of sail parameter display item
int    ySailParameter[NRSAILS+5] ; // y-coordinate of sail parameter display item
float  fSailPerpArea[NRSAILS+2] ; // effective area of sail (area perp to wind)
float  fSailPerpForce[NRSAILS+2] ; // wind force acting perpendicular to sail
float  fSailPerpFract[NRSAILS+2] ; // fraction of wind perpendicular to sail
float  xSailPlanFootLeft[NRSAILS] ; // distance of bottom left from centre of rotation
float  ySailPlanFootLeft[NRSAILS] ;
float  xSailPlanFootRight[NRSAILS] ; // distance of bottom right from centre of rotation
float  ySailPlanFootRight[NRSAILS] ;
float  xSailPlanHeadLeft[NRSAILS] ; // distance of top left from centre of rotation
float  ySailPlanHeadLeft[NRSAILS] ;
float  xSailPlanHeadRight[NRSAILS] ; // distance of top right from centre of rotation
float  ySailPlanHeadRight[NRSAILS] ;
int    iSailType[NRSAILS] ; // status bij opstarten (0 = set, 1,2,3 = reefed, 4 = furled, 5 = blown out, 6 = eased)
int    iBrigSailSequence[5][NRSAILS]  =
       { 15, 16, 17,  0,  1, 2,  3,  4, 11, 12, 13, 14,  5, 6,  7,  8,  9, 10, 
         11, 12, 13, 14,  0, 1,  2,  3,  4, 15, 16, 17,  5, 6,  7,  8,  9, 10,
         10,  5,  6,  7,  8, 9, 15, 16, 17,  0,  1,  2,  3, 4, 11, 12, 13, 14,
         10,  5,  6,  7,  8, 9, 11, 12, 13, 14,  0,  1,  2, 3,  4, 15, 16, 17,
         11, 12, 13, 14,  0, 1,  2,  3,  4, 15, 16, 17,  5, 6,  7,  8,  9, 10 } ;
         //0,1,2,3,4,5,6,7,8,10,9,11,12,13,14,15,16,17 } ;
int    iFrigateSailSequence[5][13]  =
       {  0,  1,  2,  3, 12, 4,  5,  6,  7,  8,  9, 10, 11, 
         12,  0,  1,  2,  3, 4,  5,  6,  7,  8,  9, 10, 11, 
          8,  9, 10, 11,  4, 5,  6,  7,  0,  1,  2,  3, 12, 
          8,  9, 10, 11,  4, 5,  6,  7, 12,  0,  1,  2,  3,  
          0,  1,  2,  3,  4, 5,  6,  7,  8,  9, 10, 11, 12 } ;
       // z-order of sails (to calculate shadowing)
float  fSailSSCentroid[STAYSAILS] ; 
int    iSailStatus[NRSAILS+5] ; // status bij opstarten (0 = set, 1,2,3 = reefed, 4 = furled, 5 = blown out, 6 = eased)
float  fSailTackDistance[STAYSAILS] ;
float  fSailTackElevation[STAYSAILS] ;
float  fSailTheorMaxSpeed[NRSAILS] ; // Theoretical maximum wind speed for sail
int    iSailWarning[NRSAILS] ; // warning code for sails ashiver
float  xSailWindFootLeft[NRSAILS] ; // distance ... when seen from direction of wind
float  xSailWindFootRight[NRSAILS] ; // distance ... when seen from direction of wind
float  xSailWindHeadLeft[NRSAILS] ; // distance ... when seen from direction of wind
float  xSailWindHeadRight[NRSAILS] ; // distance ... when seen from direction of wind
float  fScale ; // scale factor for Planview
float  fScaleSail ; // scale factor for Sailplan
int    iScreen ;
int    cyScroll ; // scroll bar height
int    xScrollMax ;
int    yScrollMax ;
int    xScrollPos ; // horizontal scroll in pixels
int    yScrollPos ; // vertical scroll in pixels
int    xSelected ;
int    iSeq ; 
          // parameter voor iSailSequence[]
          // [0] = mainsail drawing and jib not shadowed by foresails  
          // [1] = mainsail drawing and jib shadowed by foresails  
          // [2] = mainsail aback and jib not shadowed by foresails  
          // [3] = mainsail aback and jib shadowed by foresails  
          // [4] = only for conventional sail plan view  

float  fSetFraction[7] ; // Fraction of sail set by a particular SailStatus
float  fShipDraught ; // feet
float  fShipLength ; // feet
float  fShipMass ;
char   sShipMessage[6][41];
float  fShipTons ; // tons
float  fShipWidth ; // feet
float  fSideFactor ;
float  fSimTime ;
int    xSliders ;
int    ySliders[7] ;
int    iSpanker ;
float  fSpankerPeak ;
int    iSpacer ;
float  fSpeed ;
int    iSpeedFactor ;
char  *sStatusName[6] =
           { "Set" , "1 reef" , "2 reefs" , "3 reefs" , "Furled" , "Blown out" } ;
int    yStaysValue ;
float  fSternFactor; // modifies Frontal CSA (stern aspect is not flat rectangle)
int    cxSternView ;
int    cySternView ;
int    iTackStatus ;
int    cyTextHeight ;
int    iTick ; // save position at intervals when recording voyage
char   sTitleName [_MAX_FNAME + _MAX_EXT ] ; // for ssf files
char   sTitleName2 [_MAX_FNAME + _MAX_EXT ] ; // for srf files
float  fTopEdge ;
int    xTotals ;
int    yTotals ;
int    iTotalsHeight ;
int    iTotalsWidth ;
float  fTrack ;
int    xValues ;
float  fVerticalInertia ;
float  fWaterDragFactor ; // arbitrary scale factor for drag of water (viscosity of water = 66 * viscosity of air)
int    xWind ;
int    yWind ;
float  fWindDirection ; // in  (usual notation)
int    iWindDirIncr = 128 ;
float  fWindSpeed ; // in knots;
int    iWindSpeedIncr = 128 ;
int    xWindSpeed ;
int    iYardAngle[4] ; // brace angle of lowest yard on mast
char  *sYardLevel[5] = { "Royal yards" , "Topgallant yards" , "Upper Topsail yards", "Lower Topsail yards", "Lower yards" } ;
char  *sYardName[4] = { "Fore" , "Main" , "Mizzen", "Spanker boom" } ;
int    iYardLevelShown = 4 ; // yards to display in PlanView (4=courses; 3=lower topsails;
        //   2=upper topsails; 1=topgallants; 0=royals)

