/*-----------------------------------------
   Dlg.C -- Properties/diemsions change dialogue module
   Version date: 00.06.04
  -----------------------------------------*/

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <commdlg.h>
#include <stdlib.h>
#include "external.h"
#include "menu.h"

// Prototypes:
void     Focusser () ;
void     IslandCancel () ;
void     IslandChange () ;
void     IslandSetUp () ;
void     PropertiesAccept () ;
void     PropertiesCancel () ;
void     PropertiesChange () ;
void     PropertiesPaint () ;
void     PropertiesSetUp () ;
void     ShipDimsCancel () ;
void     ShipDimsChange () ;
void     ShipDimsSetUp () ;
void     ShipDynamicCancel () ;
void     ShipDynamicChange () ;
void     ShipDynamicSetUp () ;
void     SquareSailCancel () ;
void     SquareSailChange () ;
void     SquareSailSetUp () ;
void     StaySailCancel () ;
void     StaySailChange () ;
void     StaySailSetUp () ;

extern   void   CanShadow() ;
extern   void   DerivedSailParameters() ;
extern   void   DerivedShipParameters() ;
extern   void   ShowMessage() ;

/* --------------------------------------
   Focusser: sets focus in dialog
   Version date = 99.09.05
----------------------------------------*/

void Focusser ()
  {
  if (iFocus < 0)
    iFocus = iFields[iModifyMenu]-1 ;
  if (iFocus >= iFields[iModifyMenu])
    iFocus = 0 ;
  SetFocus(hwndPropText[iFocus]) ; 
  SendMessage(hwndPropText[iFocus],EM_SETSEL, 0, -1) ;
  }


/* --------------------------------------
   IslandCancel
   Version date = 99.09.22
----------------------------------------*/

void IslandCancel ()
  {
  int   iI ;

  // restore original values
  for (iI = 0 ; iI <= 12 ; iI ++)
    {
    fIsleLat[iI] = fOldValue[iI*3] ;
    fIsleLong[iI] = fOldValue[1+iI*3] ;
    fIsleRadius[iI] = fOldValue[2+iI*3];
    }
  }

/* --------------------------------------
   IslandChange: a value may have been changed
   Version date = 99.10.17
----------------------------------------*/

void IslandChange ()
  {
  int   iI ;

  for (iI = 0 ; iI <= 12 ; iI ++)
    {
    GetWindowText (hwndPropText[iI*3], sMessage, 12);
    fIsleLat[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[1+iI*3], sMessage, 12);
    fIsleLong[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[2+iI*3], sMessage, 12);
    fIsleRadius[iI] = atof(sMessage) ;
    }
  bMapMustBePainted = TRUE ;
  }

/* --------------------------------------
   IslandSetUp
   Version date = 99.10.17
----------------------------------------*/

void IslandSetUp ()
  {
  int   iI ;
  int   yPosn ;

  bMapMustBePainted = TRUE ;

  MoveWindow(hwndProps, 5, 255, 318, 295, TRUE) ;
  MoveWindow(hwndPropOKButton, 252,211,50,20, TRUE) ;
  MoveWindow(hwndPropCancelButton, 252,236,50,20, TRUE) ;

  for (iI = 0 ; iI <= 12 ; iI ++)
    {
    yPosn = 23 + 18*iI ;
    fOldValue[iI*3]=fIsleLat[iI] ;
    sprintf(sMessage, "%1.4f", fIsleLat[iI]) ;
    MoveWindow(hwndPropText[iI*3],70,yPosn,50,18,TRUE) ;
    SetWindowText (hwndPropText[iI*3],sMessage) ; 
    fOldValue[1+iI*3]=fIsleLong[iI] ;
    sprintf(sMessage, "%1.4f", fIsleLong[iI]) ;
    MoveWindow(hwndPropText[1+iI*3],130,yPosn,50,18,TRUE) ;
    SetWindowText (hwndPropText[1+iI*3],sMessage) ; 
    fOldValue[2+iI*3]=fIsleRadius[iI] ;
    sprintf(sMessage, "%1.4f",fIsleRadius[iI]) ;
    MoveWindow(hwndPropText[2+iI*3],190,yPosn,50,18,TRUE) ;
    SetWindowText (hwndPropText[2+iI*3],sMessage) ; 
    }
  }

/* --------------------------------------
   PropertiesAccept
   Version date = 99.10.16
----------------------------------------*/

void PropertiesAccept ()
  {
  HMENU   hMenu;
  int     iI ;

  DestroyWindow(hwndProps) ;
  DestroyWindow (hwndPropOKButton) ;
  DestroyWindow (hwndPropCancelButton) ;
  for (iI = 0 ; iI < iModifyMenu ; iI++)
    DestroyWindow(hwndPropText[iI]) ;
  UpdateWindow (hwnd) ;

  hMenu=GetMenu(hwnd) ;
  EnableMenuItem(hMenu, IDM_SHIPDIMENSIONS, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_SHIPDYNAMIC, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_SAILDIMENSIONS, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_STAYSAILS, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_ISLANDS, MF_ENABLED) ;
  iModifyMenu = 0 ;
  strcpy (sMessage, "Changes implemented") ;
  ShowMessage () ;
  }

/* --------------------------------------
   PropertiesCancel
   Version date = 99.10.16
----------------------------------------*/

void PropertiesCancel ()
  {
  HMENU   hMenu;
  int  iI ;

  DestroyWindow(hwndProps) ;
  DestroyWindow (hwndPropOKButton) ;
  DestroyWindow (hwndPropCancelButton) ;
  for (iI = 0 ; iI < iModifyMenu ; iI++)
    DestroyWindow(hwndPropText[iI]) ;
  UpdateWindow (hwnd) ;

  hMenu=GetMenu(hwnd) ;
  EnableMenuItem(hMenu, IDM_SHIPDIMENSIONS, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_SHIPDYNAMIC, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_SAILDIMENSIONS, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_STAYSAILS, MF_ENABLED) ;
  EnableMenuItem(hMenu, IDM_ISLANDS, MF_ENABLED) ;

  switch (iModifyMenu)
    {
    case 0 :
      ShipDimsCancel();
      break ;
    case 1 :
      ShipDynamicCancel() ;
      break ;
    case 2 :
      SquareSailCancel() ;
      break ;
    case 3 :
      StaySailCancel() ;
      break ;
    case 4 :
      IslandCancel() ;
    }
  iModifyMenu = 0 ;
  bPlanViewIsChanged = TRUE ;
  bSailPlanIsChanged = TRUE ;
  DerivedShipParameters () ;
  DerivedSailParameters () ;
  CanShadow() ;
  strcpy (sMessage, "Changes not implemented") ;
  ShowMessage () ;
  }

/* --------------------------------------
   PropertiesChange
   Version date = 99.09.22
----------------------------------------*/

void PropertiesChange ()
  {
  switch (iModifyMenu)
    {
    case 0 :
      ShipDimsChange();
      break ;
    case 1 :
      ShipDynamicChange() ;
      break ;
    case 2 :
      SquareSailChange() ;
      break ;
    case 3 :
      StaySailChange() ;
      break ;
    case 4 :
      IslandChange() ;
    }
  bPlanViewIsChanged = TRUE ;
  bSailPlanIsChanged = TRUE ;
  DerivedShipParameters () ;
  DerivedSailParameters () ;
  CanShadow () ;
  }

/* --------------------------------------
   PropertiesPaint
   Version date = 99.10.03
----------------------------------------*/

void PropertiesPaint ()
  {
  HDC   hdc ;
  int   iI ;
  int   xPosn, yPosn ;

  SendMessage(hwndProps, WM_SETFONT, (WPARAM) MyFont, 0) ;
  hdc = GetDC (hwndProps) ;
  SelectObject (hdc, MyFont) ;
  SelectObject (hdc, GetStockObject (LTGRAY_BRUSH)) ;
  SetBkColor (hdc, RGB (192, 192, 192)) ;

  switch (iModifyMenu)
    {
    case 0 :
      SetWindowText(hwndProps,"Modify ship dimensions") ;
      xPosn = 50 ;
      yPosn = 7 ;
      TextOut (hdc, xPosn, yPosn, "Ship length",11) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Quarterdeck length",18) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Forecastle length",17) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Gundeck height",14) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Quarterdeck height",18) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Ship width",10) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Ship draught",12) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Ship tonnage",12) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Foremast distance",17) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Mainmast distance",17) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Mizzenmast distance",19) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Jib clew distance",17) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Forecourse foot height",22) ; 
      xPosn = 210 ;
      yPosn = 7 ;
      TextOut (hdc, xPosn, yPosn, "Maincourse foot height",22) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Mizzencourse foot height",24) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Jib foot height",15) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Set fraction (1 reef)",21) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Set fraction (2 reefs)",22) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Set fraction (3 reefs)",22) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Max foreyard angle",18) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Max mainyard angle",18) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Max crossjack angle",19) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Max mizzenboom angle",20) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Rudder area",11) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Max jib angle",13) ; 
      yPosn = yPosn + 18 ;
      TextOut (hdc, xPosn, yPosn, "Max helm angle",14) ; 
      break ;
    case 1 :
      SetWindowText(hwndProps,"Modify ship dynamic properties") ;
      xPosn = 100 ;
      yPosn = 7 ;
      TextOut (hdc, xPosn, yPosn, "Water drag factor",17) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Rudder factor",13) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Bow factor",10) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Stern factor",12) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Side factor",11) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Mass Factor",11) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Rotational inertia factor",25) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Rotational drag factor",22) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Heel angle factor",17) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Heeling inertia factor",22) ; 
      yPosn = yPosn+18 ;
      TextOut (hdc, xPosn, yPosn, "Heeling drag factor",19) ; 
      break ;
    case 2 :
      SetWindowText(hwndProps,"Modify square sails") ;
      SetTextAlign(hdc, TA_RIGHT|TA_TOP) ;
      for (iI = 0 ; iI <=11 ; iI++)
        TextOut (hdc, 95, 25 + iI*18, sSailName[iI],strlen(sSailName[iI])) ; 
      TextOut (hdc, 140, 5, "Head wid.",9) ; 
      TextOut (hdc, 190, 5, "Foot wid.",9) ; 
      TextOut (hdc, 240, 5, "Depth",5) ; 
      TextOut (hdc, 290, 5, "Speed",5) ; 
      TextOut (hdc, 330, 5, "Reefs",5) ; 
      SetTextAlign(hdc, TA_LEFT|TA_TOP) ;
      break ;
    case 3 :
      SetWindowText(hwndProps,"Modify staysails") ;
      SetTextAlign(hdc, TA_RIGHT|TA_TOP) ;
      for (iI = 0 ; iI <=2 ; iI++)
        TextOut (hdc, 95, 25 + iI*18, sJibName[iI],strlen(sJibName[iI])) ; 
      TextOut (hdc, 140, 5, "Foot wid.",9) ; 
      TextOut (hdc, 190, 5, "Depth",5) ; 
      TextOut (hdc, 240, 5, "Speed",5) ; 
      SetTextAlign(hdc, TA_LEFT|TA_TOP) ;
      break ;
    case 4 :
      SetWindowText(hwndProps,"Modify islands") ;
      for (iI = 0 ; iI <=12 ; iI++)
        TextOut (hdc, 5, 25 + iI*18, sMessage,sprintf(sMessage, "Island nr %1d", iI+1)) ; 
      SetTextAlign(hdc, TA_RIGHT|TA_TOP) ;
      TextOut (hdc, 120, 5, "Lat. N",6) ; 
      TextOut (hdc, 180, 5, "Long. E",7) ; 
      TextOut (hdc, 240, 5, "Radius",6) ; 
      SetTextAlign(hdc, TA_LEFT|TA_TOP) ;
    }
  ReleaseDC (hwndProps,hdc) ;
  }

/* --------------------------------------
   PropertiesSetUp
   Version date = 99.09.22
----------------------------------------*/

void PropertiesSetUp ()
  {
  switch (iModifyMenu)
    {
    case 0 :
      ShipDimsSetUp();
      break ;
    case 1 :
      ShipDynamicSetUp() ;
      break ;
    case 2 :
      SquareSailSetUp() ;
      break ;
    case 3 :
      StaySailSetUp() ;
      break ;
    case 4 :
      IslandSetUp() ;
    }
  }

/* --------------------------------------
   ShipDimsCancel
   Version date = 99.09.08
----------------------------------------*/

void ShipDimsCancel ()
  {
  // restore original values
  fShipLength=fOldValue[0] ;
  fQDeckLength=fOldValue[1] ;
  fFocleLength=fOldValue[2] ;
  fGunDeckHeight=fOldValue[3] ;
  fQDeckHeight=fOldValue[4] ;
  fShipWidth=fOldValue[5] ;
  fShipDraught=fOldValue[6] ;
  fShipTons=fOldValue[7] ;
  fMastDistance[0]=fOldValue[8] ;
  fMastDistance[1]=fOldValue[9] ;
  fMastDistance[2]=fOldValue[10] ;
  fMastDistance[3]=fOldValue[11] ;
  fLowestSailFoot[0]=fOldValue[12] ;
  fLowestSailFoot[1]=fOldValue[13] ;
  fLowestSailFoot[2]=fOldValue[14] ;
  fLowestSailFoot[3]=fOldValue[15] ;
  fSetFraction[1]=fOldValue[16] ;
  fSetFraction[2]=fOldValue[17] ;
  fSetFraction[3]=fOldValue[18] ;
  iMaxYardAngle[0]=fOldValue[19] ;
  iMaxYardAngle[1]=fOldValue[20] ;
  iMaxYardAngle[2]=fOldValue[21] ;
  iMaxYardAngle[3]=fOldValue[22] ;
  fRudderArea=fOldValue[23] ;
  iMaxJibAngle=fOldValue[24] ;
  iMaxHelmAngle=fOldValue[25] ;
  }

/* --------------------------------------
   ShipDimsChange: a parameter may have been changed
   Version date = 99.10.03
----------------------------------------*/

void ShipDimsChange ()
  {
  GetWindowText (hwndPropText[0], sMessage, 6);
  fShipLength = atof(sMessage) ;
  GetWindowText (hwndPropText[1], sMessage, 6);
  fQDeckLength = atof(sMessage) ;
  GetWindowText (hwndPropText[2], sMessage, 6);
  fFocleLength = atof(sMessage) ;
  GetWindowText (hwndPropText[3], sMessage, 6);
  fGunDeckHeight = atof(sMessage) ;
  GetWindowText (hwndPropText[4], sMessage, 6);
  fQDeckHeight = atof(sMessage) ;
  GetWindowText (hwndPropText[5], sMessage, 6);
  fShipWidth = atof(sMessage) ;
  GetWindowText (hwndPropText[6], sMessage, 6);
  fShipDraught = atof(sMessage) ;
  GetWindowText (hwndPropText[7], sMessage, 6);
  fShipTons = atof(sMessage) ;
  GetWindowText (hwndPropText[8], sMessage, 6);
  fMastDistance[0] = atof(sMessage) ;
  GetWindowText (hwndPropText[9], sMessage, 6);
  fMastDistance[1] = atof(sMessage) ;
  GetWindowText (hwndPropText[10], sMessage, 6);
  fMastDistance[2] = atof(sMessage) ;
  GetWindowText (hwndPropText[11], sMessage, 6);
  fMastDistance[3] = atof(sMessage) ;
  GetWindowText (hwndPropText[12], sMessage, 6);
  fLowestSailFoot[0] = atof(sMessage) ;
  GetWindowText (hwndPropText[13], sMessage, 6);
  fLowestSailFoot[1] = atof(sMessage) ;
  GetWindowText (hwndPropText[14], sMessage, 6);
  fLowestSailFoot[2] = atof(sMessage) ;
  GetWindowText (hwndPropText[15], sMessage, 6);
  fLowestSailFoot[3] = atof(sMessage) ;
  GetWindowText (hwndPropText[16], sMessage, 6);
  fSetFraction[1] = atof(sMessage) ;
  GetWindowText (hwndPropText[17], sMessage, 6);
  fSetFraction[2] = atof(sMessage) ;
  GetWindowText (hwndPropText[18], sMessage, 6);
  fSetFraction[3] = atof(sMessage) ;
  GetWindowText (hwndPropText[19], sMessage, 6);
  iMaxYardAngle[0] = atoi(sMessage) ;
  GetWindowText (hwndPropText[20], sMessage, 6);
  iMaxYardAngle[1] = atoi(sMessage) ;
  GetWindowText (hwndPropText[21], sMessage, 6);
  iMaxYardAngle[2] = atoi(sMessage) ;
  GetWindowText (hwndPropText[22], sMessage, 6);
  iMaxYardAngle[3] = atoi(sMessage) ;
  GetWindowText (hwndPropText[23], sMessage, 6);
  fRudderArea = atof(sMessage) ;
  GetWindowText (hwndPropText[24], sMessage, 6);
  iMaxJibAngle = atoi(sMessage) ;
  GetWindowText (hwndPropText[25], sMessage, 6);
  iMaxHelmAngle = atof(sMessage) ;
  }

/* --------------------------------------
   ShipDimsSetUp
   Version date = 99.10.16
----------------------------------------*/

void ShipDimsSetUp ()
  {
  int  iI ;
  int  xPosn, yPosn ;

  MoveWindow(hwndProps, 5, 280, 360, 270, TRUE) ;
  MoveWindow(hwndPropOKButton, 295,194,50,20, TRUE) ;
  MoveWindow(hwndPropCancelButton, 295,219,50,20, TRUE) ;

  for (iI = 0 ; iI <= 25 ; iI ++)
    {
    if (iI<13)
      {
      xPosn = 50 ;
      yPosn = 7 +18*iI ;
      }
    else
      {
      xPosn = 210 ;
      yPosn = 7 +18*(iI-13) ;
      }
    switch (iI)
      {
      case 0 :
        fOldValue[0]=fShipLength ;
        sprintf(sMessage, "%1.1f", fShipLength) ;
        break ;
      case 1 :
        fOldValue[1]=fQDeckLength ;
        sprintf(sMessage, "%1.1f", fQDeckLength) ;
        break ;
      case 2 :
        fOldValue[2]=fFocleLength ;
        sprintf(sMessage, "%1.1f", fFocleLength) ;
        break ;
      case 3 :
        fOldValue[3]=fGunDeckHeight ;
        sprintf(sMessage, "%1.1f", fGunDeckHeight) ;
        break ;
      case 4 :
        fOldValue[4]=fQDeckHeight ;
        sprintf(sMessage, "%1.1f", fQDeckHeight) ;
        break ;
      case 5 :
        fOldValue[5]=fShipWidth ;
        sprintf(sMessage, "%1.1f", fShipWidth) ;
        break ;
      case 6 :
        fOldValue[6]=fShipDraught ;
        sprintf(sMessage, "%1.1f", fShipDraught) ;
        break ;
      case 7 :
        fOldValue[7]=fShipTons ;
        sprintf(sMessage, "%1.1f", fShipTons) ;
        break ;
      case 8 :
        fOldValue[8]=fMastDistance[0] ;
        sprintf(sMessage, "%1.1f", fMastDistance[0]) ;
        break ;
      case 9 :
        fOldValue[9]=fMastDistance[1] ;
        sprintf(sMessage, "%1.1f", fMastDistance[1]) ;
        break ;
      case 10 :
        fOldValue[10]=fMastDistance[2] ;
        sprintf(sMessage, "%1.1f", fMastDistance[2]) ;
        break ;
      case 11 :
        fOldValue[11]=fMastDistance[3] ;
        sprintf(sMessage, "%1.1f", fMastDistance[3]) ;
        break ;
      case 12 :
        fOldValue[12]=fLowestSailFoot[0] ;
        sprintf(sMessage, "%1.1f", fLowestSailFoot[0]) ;
        break ;
      case 13 :
        fOldValue[13]=fLowestSailFoot[1] ;
        sprintf(sMessage, "%1.1f", fLowestSailFoot[1]) ;
        break ;
      case 14 :
        fOldValue[14]=fLowestSailFoot[2] ;
        sprintf(sMessage, "%1.1f", fLowestSailFoot[2]) ;
        break ;
      case 15 :
        fOldValue[15]=fLowestSailFoot[3] ;
        sprintf(sMessage, "%1.1f", fLowestSailFoot[3]) ;
        break ;
      case 16 :
        fOldValue[16]=fSetFraction[1] ;
        sprintf(sMessage, "%1.2f", fSetFraction[1]) ;
        break ;
      case 17 :
        fOldValue[17]=fSetFraction[2] ;
        sprintf(sMessage, "%1.2f", fSetFraction[2]) ;
        break ;
      case 18 :
        fOldValue[18]=fSetFraction[3] ;
        sprintf(sMessage, "%1.2f", fSetFraction[3]) ;
        break ;
      case 19 :
        fOldValue[19]=iMaxYardAngle[0] ;
        sprintf(sMessage, "%d", iMaxYardAngle[0]) ;
        break ;
      case 20 :
        fOldValue[20]=iMaxYardAngle[1] ;
        sprintf(sMessage, "%1d", iMaxYardAngle[1]) ;
        break ;
      case 21 :
        fOldValue[21]=iMaxYardAngle[2] ;
        sprintf(sMessage, "%1d", iMaxYardAngle[2]) ;
        break ;
      case 22 :
        fOldValue[22]=iMaxYardAngle[3] ;
        sprintf(sMessage, "%1d", iMaxYardAngle[3]) ;
        break ;
      case 23 :
        fOldValue[23]=fRudderArea ;
        sprintf(sMessage, "%1.1f", fRudderArea) ;
        break ;
      case 24:
        fOldValue[24]=iMaxJibAngle ;
        sprintf(sMessage, "%1d", iMaxJibAngle) ;
        break ;
      case 25 :
        fOldValue[25]=iMaxHelmAngle ;
        sprintf(sMessage, "%1d", iMaxHelmAngle) ;
      }
    MoveWindow(hwndPropText[iI],xPosn-45,yPosn-3,40,18,TRUE) ;
    SetWindowText (hwndPropText[iI],sMessage) ; 
    }
  }

/* --------------------------------------
   ShipDynamicCancel
   Version date = 00.06.04
----------------------------------------*/

void ShipDynamicCancel ()
  {
  // restore original values
  fWaterDragFactor=fOldValue[0] ;
  fRudderFactor=fOldValue[1] ;
  fBowFactor=fOldValue[2] ;
  fSternFactor=fOldValue[3] ;
  fSideFactor=fOldValue[4] ;
  fMassFactor=fOldValue[5] ;
  fRotatInertFactor=fOldValue[6] ;
  fRotatDragFactor=fOldValue[7] ;
  fHeelAngleFactor=fOldValue[8] ;
  fHeelInertFactor=fOldValue[9] ;
  fHeelDragFactor=fOldValue[10] ;
  }

/* --------------------------------------
   ShipDynamicChange: a value may have been changed
   Version date = 99.10.03
----------------------------------------*/

void ShipDynamicChange ()
  {
  GetWindowText (hwndPropText[0], sMessage, 12);
  fWaterDragFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[1], sMessage, 12);
  fRudderFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[2], sMessage, 12);
  fBowFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[3], sMessage, 12);
  fSternFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[4], sMessage, 12);
  fSideFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[5], sMessage, 12);
  fMassFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[6], sMessage, 12);
  fRotatInertFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[7], sMessage, 12);
  fRotatDragFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[8], sMessage, 12);
  fHeelAngleFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[9], sMessage, 12);
  fHeelInertFactor = atof(sMessage) ;
  GetWindowText (hwndPropText[10], sMessage, 12);
  fHeelDragFactor = atof(sMessage) ;
  }

/* --------------------------------------
   ShipDynamicSetUp
   Version date = 00.06.04
----------------------------------------*/

void ShipDynamicSetUp ()
  {
  int   iI ;
  int   xPosn, yPosn ;

  MoveWindow(hwndProps, 5, 260, 225, 290, TRUE) ;
  MoveWindow(hwndPropOKButton, 160,210,50,20, TRUE) ;
  MoveWindow(hwndPropCancelButton, 160,235,50,20, TRUE) ;

  xPosn = 100 ;
  for (iI = 0 ; iI <= 10 ; iI ++)
    {
    yPosn = 7 +18*iI ;
    switch (iI)
      {
      case 0 :
        fOldValue[0]=fWaterDragFactor ;
        sprintf(sMessage, "%1.0f", fWaterDragFactor) ;
        break ;
      case 1 :
        fOldValue[1]=fRudderFactor ;
        sprintf(sMessage, "%1.0f", fRudderFactor) ;
        break ;
      case 2 :
        fOldValue[2]=fBowFactor ;
        sprintf(sMessage, "%1.5f", fBowFactor) ;
        break ;
      case 3 :
        fOldValue[3]=fSternFactor ;
        sprintf(sMessage, "%1.5f", fSternFactor) ;
        break ;
      case 4 :
        fOldValue[4]=fSideFactor ;
        sprintf(sMessage, "%1.5f", fSideFactor) ;
        break ;
      case 5 :
        fOldValue[5]=fMassFactor ;
        sprintf(sMessage, "%1.5f", fMassFactor) ;
        break ;
      case 6 :
        fOldValue[6]=fRotatInertFactor ;
        sprintf(sMessage, "%1.5f", fRotatInertFactor) ;
        break ;
      case 7 :
        fOldValue[7]=fRotatDragFactor ;
        sprintf(sMessage, "%1.5f", fRotatDragFactor) ;
        break ;
      case 8 :
        fOldValue[8]=fHeelAngleFactor ;
        sprintf(sMessage, "%1.5f", fHeelAngleFactor) ;
        break ;
      case 9 :
        fOldValue[9]=fHeelInertFactor ;
        sprintf(sMessage, "%1.5f", fHeelInertFactor) ;
        break ;
      case 10 :
        fOldValue[10]=fHeelDragFactor ;
        sprintf(sMessage, "%1.5f", fHeelDragFactor) ;
        break ;
      }
    MoveWindow(hwndPropText[iI],xPosn-95,yPosn-3,80,18,TRUE) ;
    SetWindowText (hwndPropText[iI],sMessage); 
    }
  }

/* --------------------------------------
   SquareSailCancel
   Version date = 99.09.09
----------------------------------------*/

void SquareSailCancel ()
  {
  int   iI ;

  // restore original values
  for (iI = 0 ; iI <= 11 ; iI ++)
    {
    fHeadWidth[iI] = fOldValue[iI*5] ;
    fFootWidth[iI] = fOldValue[1+iI*5] ;
    fSailDepth[iI] = fOldValue[2+iI*5];
    fTheorMaxSpeed[iI] = fOldValue[3+iI*5];
    iMaxReefs[iI] = fOldValue[4+iI*5];
    }
  }

/* --------------------------------------
   SquareSailChange: a value may have been changed
   Version date = 99.10.03
----------------------------------------*/

void SquareSailChange ()
  {
  int   iI ;

  for (iI = 0 ; iI <= 11 ; iI ++)
    {
    GetWindowText (hwndPropText[iI*5], sMessage, 12);
    fHeadWidth[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[1+iI*5], sMessage, 12);
    fFootWidth[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[2+iI*5], sMessage, 12);
    fSailDepth[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[3+iI*5], sMessage, 12);
    fTheorMaxSpeed[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[4+iI*5], sMessage, 12);
    iMaxReefs[iI] = atoi(sMessage) ;
    }
  }

/* --------------------------------------
   SquareSailSetUp
   Version date = 99.10.16
----------------------------------------*/

void SquareSailSetUp ()
  {
  int  iI ;
  int  yPosn ;

  MoveWindow(hwndProps, 5, 280, 405, 270, TRUE) ;
  MoveWindow(hwndPropOKButton, 340,194,50,20, TRUE) ;
  MoveWindow(hwndPropCancelButton, 340,219,50,20, TRUE) ;

  for (iI = 0 ; iI <= 11 ; iI ++)
    {
    yPosn = 23 + 18*iI ;
    fOldValue[iI*5]=fHeadWidth[iI] ;
    sprintf(sMessage, "%1.1f", fHeadWidth[iI]) ;
    MoveWindow(hwndPropText[iI*5],100,yPosn,40,18,TRUE) ;
    SetWindowText (hwndPropText[iI*5],sMessage) ; 
    fOldValue[1+iI*5]=fFootWidth[iI] ;
    sprintf(sMessage, "%1.1f", fFootWidth[iI]) ;
    MoveWindow(hwndPropText[1+iI*5],150,yPosn,40,18,TRUE) ;
    SetWindowText (hwndPropText[1+iI*5],sMessage) ; 
    fOldValue[2+iI*5]=fSailDepth[iI] ;
    sprintf(sMessage, "%1.1f", fSailDepth[iI]) ;
    MoveWindow(hwndPropText[2+iI*5],200,yPosn,40,18,TRUE) ;
    SetWindowText (hwndPropText[2+iI*5],sMessage) ; 
    fOldValue[3+iI*5]=fTheorMaxSpeed[iI] ;
    sprintf(sMessage, "%1.1f", fTheorMaxSpeed[iI]) ;
    MoveWindow(hwndPropText[3+iI*5],250,yPosn,40,18,TRUE) ;
    SetWindowText (hwndPropText[3+iI*5],sMessage) ; 
    fOldValue[4+iI*5]=iMaxReefs[iI] ;
    sprintf(sMessage, "%1d", iMaxReefs[iI]) ;
    MoveWindow(hwndPropText[4+iI*5],300,yPosn,30,18,TRUE) ;
    SetWindowText (hwndPropText[4+iI*5],sMessage) ; 
    }
  }

/* --------------------------------------
   StaySailCancel
   Version date = 99.09.19
----------------------------------------*/

void StaySailCancel ()
  {
  int   iI ;

  // restore original values
  for (iI = 0 ; iI <= 2 ; iI ++)
    {
    fJibFootWidth[iI] = fOldValue[iI*3] ;
    fJibDepth[iI] = fOldValue[1+iI*3] ;
    fJibTheorMaxSpeed[iI] = fOldValue[2+iI*3];
    }
  }

/* --------------------------------------
   StaySailChange: a value may have been changed
   Version date = 99.10.03
----------------------------------------*/

void StaySailChange ()
  {
  int   iI ;

  for (iI = 0 ; iI <= 2 ; iI ++)
    {
    GetWindowText (hwndPropText[iI*3], sMessage, 12);
    fJibFootWidth[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[1+iI*3], sMessage, 12);
    fJibDepth[iI] = atof(sMessage) ;
    GetWindowText (hwndPropText[2+iI*3], sMessage, 12);
    fJibTheorMaxSpeed[iI] = atof(sMessage) ;
    }
  }

/* --------------------------------------
   StaySailSetUp
   Version date = 99.10.16
----------------------------------------*/

void StaySailSetUp ()
  {
  int  iI ;
  int  yPosn ;

  MoveWindow(hwndProps, 5, 435, 325, 110, TRUE) ;
  MoveWindow(hwndPropOKButton, 260,30,50,20, TRUE) ;
  MoveWindow(hwndPropCancelButton, 260,55,50,20, TRUE) ;

  for (iI = 0 ; iI <= 2 ; iI ++)
    {
    yPosn = 23 + 18*iI ;
    fOldValue[iI*3]=fJibFootWidth[iI] ;
    sprintf(sMessage, "%1.1f", fJibFootWidth[iI]) ;
    MoveWindow(hwndPropText[iI*3],100,yPosn,40,18,TRUE) ;
    SetWindowText (hwndPropText[iI*3],sMessage) ; 
    fOldValue[1+iI*3]=fJibDepth[iI] ;
    sprintf(sMessage, "%1.1f", fJibDepth[iI]) ;
    MoveWindow(hwndPropText[1+iI*3],150,yPosn,40,18,TRUE) ;
    SetWindowText (hwndPropText[1+iI*3],sMessage) ; 
    fOldValue[2+iI*3]=fJibTheorMaxSpeed[iI] ;
    sprintf(sMessage, "%1.1f",fJibTheorMaxSpeed[iI]) ;
    MoveWindow(hwndPropText[2+iI*3],200,yPosn,40,18,TRUE) ;
    SetWindowText (hwndPropText[2+iI*3],sMessage) ; 
    }
  }
